# $Id: fusion_logic.tac,v 1.5 2010/01/19 11:10:11 acau Exp $

# taccle Declarations
%token ID NEWLINE TRUE FALSE CLB CRB TLB TRB SAT PSAT VLD PVLD ENF PENF INF PINF
%token OR
%token AND
%token FECHOP
%token FIN
%token CHOPSTAR
%token TEST
%token STEP
%token NEXT
%token NOT

%left OR
%left AND
%left USTOR
%left USTAND
%left UTROR
%left UTRAND
%left UFEOR
%left UCHOP
%left FECHOP
%left UFIN
%left UCHOPSTAR
%left UTEST
%left USTEP
%left UNEXT
%left UNOT


# Grammar follows
%%
start: line NEWLINE start
 | line
;

line: cfl    { return $1 }
 | error     { puts " -- error "; return "error" }
 | # empty
;

cfl:  SAT fl                         { set _ [FLsat $2]  }
    | VLD fl                         { set _ [FLvld $2]  }
    | ENF fl                         { set _ [FLenf $2]  }
    | INF fl                         { set _ [FLinf $2]  }
    | PSAT pl                         { set _ [PLsat $2]  }
    | PVLD pl                         { set _ [PLvld $2]  }
    | PENF pl                         { set _ [PLenf $2]  }
    | PINF pl                         { set _ [PLinf $2]  }
;

fl:   ID                             { set _ $1              }
    | TRUE                           { set _ $1              }
    | FALSE                          { set _ $1              }
    | TLB fe TRB fl %prec UCHOP      { set _ [FLchop $2 $4]  }
    | fl OR fl                       { set _ [FLor $1 $3]    }
    | fl AND fl                      { set _ [FLand $1 $3]   }
    | CLB fl CRB                     { set _ $2              }
    | NOT fl %prec UNOT              { set _ [FLnot $2]      }
;

pl:   FIN ID %prec UFIN              { set _ [PLfin $2]      }
    | TRUE                           { set _ $1              }
    | FALSE                          { set _ $1              }
    | pl TLB fe TRB %prec UCHOP      { set _ [PLchop $1 $3]  }
    | pl OR pl                       { set _ [PLor $1 $3]    }
    | pl AND pl                      { set _ [PLand $1 $3]   }
    | CLB pl CRB                     { set _ $2              }
    | NOT pl %prec UNOT              { set _ [PLnot $2]      }
;

fe:   CHOPSTAR fe %prec UCHOPSTAR  { set _ [FEchopstar $2]  }
    | STEP tr  %prec USTEP         { set _ [FEstep $2 ]     }
    | TEST st  %prec UTEST         { set _ [FEtest $2]      }
    | fe OR fe %prec UFEOR         { set _ [FEor $1 $3]     }
    | fe FECHOP fe                 { set _ [FEchop $1 $3 ]  }
    | CLB fe CRB                   { set _ $2               } 
;

tr:   ID                      { set _ $1             }
    | TRUE                    { set _ $1             }  
    | FALSE                   { set _ $1             }
    | tr OR tr  %prec UTROR   { set _ [TRor $1 $3]   }
    | tr AND tr %prec UTRAND  { set _ [TRand $1 $3]  }
    | CLB tr CRB              { set _ $2             }
    | NEXT st %prec UNEXT     { set _ [TRnext $2]    }   
    | NOT tr  %prec UNOT      { set _ [TRnot $2]     }
;


st:   ID                       { set _ $1             }
     | TRUE                    { set _ $1             }
     | FALSE                   { set _ $1             }
     | st OR st %prec USTOR    { set _ [STor $1 $3]   }
     | st AND st %prec USTAND  { set _ [STand $1 $3]  }
     | CLB st CRB              { set _ $2             }
     | NOT st %prec UNOT       { set _ [STnot $2]     }
;

%%

if {![info exist ::starkit::topdir]} {
 source fusion_logic_commands.tcl
 source scanner_fusion_logic.tcl
} else {
 source $::starkit::topdir/fusion_logic_commands.tcl
 source $::starkit::topdir/scanner_fusion_logic.tcl
}


